# $Revision: 1.30 $, $Date: 2011/12/09 22:06:21 $
#
# TODO:
# - separate -devel with ExtUtils::Embed and friends?

%define		apxs		/usr/sbin/apxs
%define		mod_name	rails
%define		apacheconfdir	%(%{apxs} -q SYSCONFDIR 2>/dev/null)/conf.d
%define		apachelibdir	%(%{apxs} -q LIBEXECDIR 2>/dev/null)
%define		apacheprefix	%(%{apxs} -q PREFIX 2>/dev/null)
%define		apachelibdir2	%(%{apxs} -q LIBEXECDIR 2>/dev/null | %{__sed} 's|%{apacheprefix}||')

Summary:	A module to bridge Ruby on Rails to Apache
Name:		apache-mod_rails
Version:	3.0.11
Release:	3
License:	Apache
Group:		Networking/Daemons/HTTP
Source0:	http://rubygems.org/downloads/passenger-%{version}.gem
# Source0-md5:	c0cafef2c5ba522310602f451ea4c941
Source1:	%{name}.conf
Patch0:		%{name}-nogems.patch
Patch1:		%{name}-alias+public.patch
Patch2:		%{name}-build.patch
URL:		http://www.modrails.com
BuildRequires:	apache-base >= 2.0.55-1
BuildRequires:	apache-devel >= 2.0.55-1
BuildRequires:	apache-tools >= 2.0.55-1
BuildRequires:	apr-devel >= 1:1.0.0
BuildRequires:	apr-util-devel >= 1:1.0.0
#BuildRequires:	asciidoc
BuildRequires:	curl-devel
BuildRequires:	libstdc++-devel
BuildRequires:	openssl-devel
BuildRequires:	pkgconfig
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.559
BuildRequires:	ruby-devel
BuildRequires:	ruby-rake >= 0.8.0
BuildRequires:	sed >= 4.0
BuildRequires:	zlib-devel
%requires_ge_to	ruby ruby-devel
Provides:	apache(mod_rails)
Obsoletes:	apache-mod_rails-rdoc
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Phusion Passenger — a.k.a. mod_rails — makes deployment of
applications built on the revolutionary Ruby on Rails web framework a
breeze. It follows the usual Ruby on Rails conventions, such as
"Don’t-Repeat-Yourself".

%package ri
Summary:	ri documentation for Apache mod_rails
Summary(pl.UTF-8):	Dokumentacja w formacie ri dla Apache mod_rails
Group:		Documentation
Requires:	ruby

%description ri
ri documentation for Apache mod_rails.

%description ri -l pl.UTF-8
Dokumentacji w formacie ri dla Apache mod_rails.

%prep
%setup -q -c
%{__tar} xf %{SOURCE0} -O data.tar.gz | %{__tar} xz
find -newer README -o -print0 | xargs -0 touch --reference %{SOURCE0}
%patch0 -p1
%patch1 -p0
%patch2 -p1

%{__sed} -i -e 's!/usr/lib/!%{_libdir}/!g' ext/common/ResourceLocator.h

%build
(cd ext/libev ; %{__autoconf})

rake apache2 \
	RELEASE=yes \
	OPTIMIZE=yes \
	APXS2=%{apxs} \
	CXXFLAGS="%{rpmcxxflags}" \
	CFLAGS="%{rpmcflags}" \
	CXX=%{__cxx} \
	CC=%{__cc}

rdoc --ri --op ri lib ext/ruby
%{__rm} -r ri/{ConditionVariable,Exception,GC,IO,Object,Process,Signal}
%{__rm} ri/{cache.ri,created.rid}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{apachelibdir},%{apacheconfdir},%{_mandir}/man{1,8}} \
	$RPM_BUILD_ROOT{%{ruby_rubylibdir},%{ruby_archdir},%{ruby_ridir}} \
	$RPM_BUILD_ROOT%{_bindir} \
	$RPM_BUILD_ROOT%{_libdir}/phusion-passenger/agents/apache2 \
	$RPM_BUILD_ROOT%{_datadir}/phusion-passenger/helper-scripts

install ext/apache2/mod_passenger.so $RPM_BUILD_ROOT%{apachelibdir}

install ext/ruby/ruby-*/passenger_native_support.so $RPM_BUILD_ROOT%{ruby_archdir}

install bin/passenger-{config,make-enterprisey,memory-stats,status} bin/passenger \
	$RPM_BUILD_ROOT%{_bindir}

install agents/PassengerLoggingAgent agents/PassengerWatchdog $RPM_BUILD_ROOT%{_libdir}/phusion-passenger/agents
install agents/apache2/PassengerHelperAgent $RPM_BUILD_ROOT%{_libdir}/phusion-passenger/agents/apache2

install helper-scripts/* $RPM_BUILD_ROOT%{_datadir}/phusion-passenger/helper-scripts

cp -a lib/* $RPM_BUILD_ROOT%{ruby_rubylibdir}
install man/*.1 $RPM_BUILD_ROOT%{_mandir}/man1
install man/*.8 $RPM_BUILD_ROOT%{_mandir}/man8

cp -a ri/* $RPM_BUILD_ROOT%{ruby_ridir}

install %{SOURCE1} $RPM_BUILD_ROOT%{apacheconfdir}/75_mod_rails.conf

%{__sed} -i -e 's|#!/usr/bin/env ruby|#!%{_bindir}/ruby|' \
	$RPM_BUILD_ROOT%{_bindir}/passenger \
	$RPM_BUILD_ROOT%{_bindir}/passenger-* \
	$RPM_BUILD_ROOT%{_datadir}/phusion-passenger/helper-scripts/*

%{__sed} -i -e 's|#!/usr/bin/env python|#!%{_bindir}/python|' \
	$RPM_BUILD_ROOT%{ruby_rubylibdir}/phusion_passenger/wsgi/request_handler.py

%clean
rm -rf $RPM_BUILD_ROOT

%post
%service -q httpd restart

%postun
if [ "$1" = "0" ]; then
	%service -q httpd restart
fi

%files
%defattr(644,root,root,755)
%doc INSTALL README doc/{A*.txt,Security*.txt,*Apache.txt}
%doc doc/{A*.html,Security*.html,*Apache.html,images}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{apacheconfdir}/*.conf
%attr(755,root,root) %{apachelibdir}/*
%attr(755,root,root) %{_bindir}/passenger
%attr(755,root,root) %{_bindir}/passenger-*
%attr(755,root,root) %{ruby_archdir}/*.so
%dir %{_libdir}/phusion-passenger
%dir %{_libdir}/phusion-passenger/agents
%attr(755,root,root) %{_libdir}/phusion-passenger/agents/Passenger*
%dir %{_libdir}/phusion-passenger/agents/apache2
%attr(755,root,root) %{_libdir}/phusion-passenger/agents/apache2/Passenger*
%{ruby_rubylibdir}/phusion_passenger
%{ruby_rubylibdir}/phusion_passenger.rb
%dir %{_datadir}/phusion-passenger
%dir %{_datadir}/phusion-passenger/helper-scripts
%attr(755,root,root) %{_datadir}/phusion-passenger/helper-scripts/*
%{_mandir}/man1/*
%{_mandir}/man8/*

%files ri
%defattr(644,root,root,755)
%{ruby_ridir}/PhusionPassenger

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: apache-mod_rails.spec,v $
Revision 1.30  2011/12/09 22:06:21  baggins
- rel 3

Revision 1.29  2011/12/09 13:42:56  baggins
- require ruby version at least that was used to build (build with 1.9.3
  causes unresolved symbols when run on 1.9.2)

Revision 1.28  2011/12/09 12:47:28  baggins
- rel 2

Revision 1.27  2011/12/09 11:35:29  baggins
- 3.0.11

Revision 1.26  2011/10/10 20:19:19  baggins
- don't list files twice
- get rid of the /usr/bin/env shebang

Revision 1.25  2011/10/10 20:10:26  baggins
- 3.0.9
- rdoc documentation is totally gone this time

Revision 1.24  2011/08/31 06:59:24  arekm
- release 3

Revision 1.23  2011/08/03 06:11:59  baggins
- release 2

Revision 1.22  2011/04/07 10:21:33  baggins
- rel 1

Revision 1.21  2011/04/07 10:17:51  baggins
- renumbered patches

Revision 1.20  2011/04/07 10:17:15  baggins
- rdoc disappeared from dist, build it here

Revision 1.19  2011/04/07 10:07:20  baggins
- 3.0.6

Revision 1.18  2011/03/31 11:33:37  baggins
- rel 1

Revision 1.17  2011/03/31 11:24:11  baggins
- 3.0.5
- updated BRs
- don't install irrelevant docs
- clean solution to passing our CXXFLAGS, etc. to rake
- restored alias+public patch (THE ISSUE IS STILL THERE!)
  aria - DON'T REMOVE PATCHES JUST BECAUSE YOU DON'T KNOW HOW TO UPDATE THEM!

Revision 1.16  2011/02/02 12:15:26  glen
- rpmlint: W: unexpanded-macro %{pkgname}

Revision 1.15  2010/12/04 20:02:01  baggins
- rel 2

Revision 1.14  2010/12/04 19:56:52  baggins
- fix problems with apache graceful restarts, see
  http://code.google.com/p/phusion-passenger/issues/detail?id=569

Revision 1.13  2010/12/02 19:00:58  baggins
- fix BR
- no need to separately build docs

Revision 1.12  2010/11/25 01:15:31  aredridel
- Be more specific about path change

Revision 1.11  2010/11/25 01:05:11  aredridel
- 3.0.0. Not finished yet.

Revision 1.10  2010/08/29 05:34:06  aredridel
- 2.2.15
- patch out rubygems

Revision 1.9  2010/03/13 22:43:01  sparky
- BR: libstdc++-devel, rpm-pythonprov

Revision 1.8  2010/03/04 14:03:02  baggins
- rel 1

Revision 1.7  2010/03/04 00:04:11  baggins
- add Alias support, details in patch

Revision 1.6  2010/03/03 16:16:40  baggins
- setup.rb is not able to do the job, we have to install manually

Revision 1.5  2010/03/03 16:12:45  baggins
- updated to 2.2.10
- looks working

Revision 1.4  2008/10/25 15:50:02  blues
- HTTP group

Revision 1.3  2008/06/04 17:10:51  cactus
- up to 1.0.5
- missing native_support.so lib

Revision 1.2  2008-06-04 16:21:55  cactus
- up to 1.0.5
- updated TODO
- now works w/o patch but need to find different sollution to pass cflags of apr-util-1 to CPPFLAGS
- BR: apache-base, apache-tools, pkgconfig, ruby-RubyGems, sed
- adapter

Revision 1.1  2008-04-13 18:51:07  aredridel
- added
